<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package architecture_construction
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function architecture_construction_body_classes( $classes ) {
  global $post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

	if ( is_multi_author() ) {
		$classes[] = 'group-blog ';
	}

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( architecture_construction_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
    	$classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

	return $classes;
}
add_filter( 'body_class', 'architecture_construction_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function architecture_construction_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'architecture_construction_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function architecture_construction_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'architecture_construction_excerpt_more' );

if( ! function_exists( 'architecture_construction_footer_credit' ) ):
/**
 * Footer Credits
*/
function architecture_construction_footer_credit(){
    $architecture_construction_copyright_text = get_theme_mod( 'architecture_construction_footer_copyright_text' );

    $architecture_construction_text  = '<div class="site-info"><div class="container"><span class="copyright">';
    if( $architecture_construction_copyright_text ){
        $architecture_construction_text .= wp_kses_post( $architecture_construction_copyright_text ); 
    }else{
        $architecture_construction_text .= esc_html__( '&copy; ', 'architecture-construction' ) . date_i18n( esc_html__( 'Y', 'architecture-construction' ) ); 
        $architecture_construction_text .= ' <a href="' . esc_url( home_url( '/' ) ) . '">' . esc_html( get_bloginfo( 'name' ) ) . '</a>'. esc_html__( '. All Rights Reserved.', 'architecture-construction' );
    }
    $architecture_construction_text .= '</span>';
    $architecture_construction_text .= '<span class="by"> <a href="' . esc_url( 'https://themeignite.com/products/free-architecture-wordpress-theme' ) .'" rel="nofollow" target="_blank">' . ARCHITECTURE_CONSTRUCTION_THEME_NAME . ' </a>' . esc_html__( 'By ', 'architecture-construction' ) . '' . '<a href="' . esc_url( 'https://themeignite.com' ) .'" rel="nofollow" target="_blank">' . esc_html__( 'Themeignite', 'architecture-construction' ) . '</a>';
    $architecture_construction_text .= sprintf( esc_html__( ' Powered By %s', 'architecture-construction' ), '<a href="'. esc_url( __( 'https://wordpress.org/', 'architecture-construction' ) ) .'" target="_blank">WordPress</a>.' );
    if ( function_exists( 'the_privacy_policy_link' ) ) {
        $architecture_construction_text .= get_the_privacy_policy_link();
    }
    $architecture_construction_text .= '</span></div></div>';
    echo apply_filters( 'architecture_construction_footer_text', $architecture_construction_text );
}
add_action( 'architecture_construction_footer', 'architecture_construction_footer_credit' );
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'architecture_construction_woocommerce_activated' ) ) {
  function architecture_construction_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'architecture_construction_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function architecture_construction_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $aria_req = ( $req ? " aria-required='true'" : '' );
    $required = ( $req ? " required" : '' );
    $author   = ( $req ? __( 'Name*', 'architecture-construction' ) : __( 'Name', 'architecture-construction' ) );
    $email    = ( $req ? __( 'Email*', 'architecture-construction' ) : __( 'Email', 'architecture-construction' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'architecture-construction' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $author ) . '" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" size="30"' . $aria_req . $required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'architecture-construction' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $email ) . '" type="text" value="' . esc_attr(  $commenter['comment_author_email'] ) . '" size="30"' . $aria_req . $required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'architecture-construction' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'architecture-construction' ) . '" type="text" value="' . esc_attr( $commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'architecture_construction_change_comment_form_default_fields' );

if( ! function_exists( 'architecture_construction_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function architecture_construction_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'architecture-construction' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'architecture-construction' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'architecture_construction_change_comment_form_defaults' );

if( ! function_exists( 'architecture_construction_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function architecture_construction_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
	/**
	 * Triggered after the opening <body> tag.
    */
	do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'architecture_construction_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function architecture_construction_get_fallback_svg( $architecture_construction_post_thumbnail ) {
    if( ! $architecture_construction_post_thumbnail ){
        return;
    }
    
    $architecture_construction_image_size = architecture_construction_get_image_sizes( $architecture_construction_post_thumbnail );
     
    if( $architecture_construction_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $architecture_construction_image_size['width'] ); ?> <?php echo esc_attr( $architecture_construction_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $architecture_construction_image_size['width'] ); ?>" height="<?php echo esc_attr( $architecture_construction_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function architecture_construction_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-titillium',
        wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Titillium+Web:ital,wght@0,200;0,300;0,400;0,600;0,700;0,900;1,200;1,300;1,400;1,600;1,700&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'architecture_construction_enqueue_google_fonts' );


if( ! function_exists( 'architecture_construction_site_branding' ) ) :
/**
 * Site Branding
*/
function architecture_construction_site_branding(){
    $architecture_construction_logo_site_title = get_theme_mod( 'header_site_title', 1 );
    $architecture_construction_tagline = get_theme_mod( 'header_tagline', false );
    $architecture_construction_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding text-center" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '100'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($architecture_construction_logo_site_title):
             if (is_front_page()): ?>
             <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('architecture_construction_site_title_size', '30')); ?>px;">
                <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
            </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($architecture_construction_tagline) :
            $architecture_construction_description = get_bloginfo('description', 'display');
            if ($architecture_construction_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $architecture_construction_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'architecture_construction_navigation' ) ) :
/**
 * Site Navigation
*/
function architecture_construction_navigation(){
    $architecture_construction_header_btn_text     = get_theme_mod( 'architecture_construction_header_btn_text' );
    $architecture_construction_header_btn_url     = get_theme_mod( 'architecture_construction_header_btn_url' );
    ?>
    <div class="header-menu-inner">
        <div class="row">
            <div class="col-lg-9 col-md-9 align-self-center">
                <nav class="main-navigation" id="site-navigation"  role="navigation">
                    <?php 
                    wp_nav_menu( array( 
                        'theme_location' => 'primary', 
                        'menu_id' => 'primary-menu' 
                    ) ); 
                    ?>
                </nav>
            </div>
            <div class="col-lg-3 col-md-12 align-self-center">
                <?php if ( $architecture_construction_header_btn_text ){?>
                    <div class="menudiv-button">
                        <a href="<?php echo esc_url($architecture_construction_header_btn_url);?>"> <?php echo esc_html($architecture_construction_header_btn_text);?></a>
                    </div>
                <?php } ?>
            </div>
        </div>
    </div>
    <?php
}
endif;


if( ! function_exists( 'architecture_construction_top_header' ) ) :
/**
 * Header Start
*/
function architecture_construction_top_header(){
    $architecture_construction_header     = get_theme_mod( 'architecture_construction_header_setting',false );
    $architecture_construction_social_icon     = get_theme_mod( 'architecture_construction_social_icon_setting',true );
    $architecture_construction_header_line     = get_theme_mod( 'architecture_construction_header_line' );
    ?>
    <?php if ( $architecture_construction_header ){?>
        <div class="top-header">
            <div class="container">
                <div class="row">
                    <div class="col-lg-8 col-md-7 align-self-center">
                        <?php if ( $architecture_construction_header_line ){?>
                            <p class="mb-0"><?php echo esc_html( $architecture_construction_header_line );?></p>
                        <?php } ?>
                    </div>
                    <div class="col-lg-4 col-md-5 align-self-center">
                        <?php if ( $architecture_construction_social_icon ){?>
                            <div class="social-links">
                                <?php 
                                    $architecture_construction_social_link1 = get_theme_mod( 'architecture_construction_social_link_1' );
                                    $architecture_construction_social_link2 = get_theme_mod( 'architecture_construction_social_link_2' );
                                    $architecture_construction_social_link3 = get_theme_mod( 'architecture_construction_social_link_3' );
                                    $architecture_construction_social_link4 = get_theme_mod( 'architecture_construction_social_link_4' );

                                    if ( ! empty( $architecture_construction_social_link1 ) ) {
                                        echo '<a class="social1" href="' . esc_url( $architecture_construction_social_link1 ) . '" target="_blank"><i class="fab fa-facebook-f"></i></a>';
                                    }
                                    if ( ! empty( $architecture_construction_social_link2 ) ) {
                                        echo '<a class="social2" href="' . esc_url( $architecture_construction_social_link2 ) . '" target="_blank"><i class="fab fa-twitter"></i></a>';
                                    } 
                                    if ( ! empty( $architecture_construction_social_link3 ) ) {
                                        echo '<a class="social3" href="' . esc_url( $architecture_construction_social_link3 ) . '" target="_blank"><i class="fab fa-instagram"></i></a>';
                                    }
                                    if ( ! empty( $architecture_construction_social_link4 ) ) {
                                        echo '<a class="social4" href="' . esc_url( $architecture_construction_social_link4 ) . '" target="_blank"><i class="fab fa-pinterest-p"></i></a>';
                                    }
                                ?>
                            </div>
                        <?php } ?>
                    </div>
                </div>
            </div>
        </div>
    <?php } ?>
    <?php
}
endif;

if( ! function_exists( 'architecture_construction_header_info' ) ) :
/**
 * Header Info
*/
function architecture_construction_header_info(){
    $architecture_construction_location     = get_theme_mod( 'architecture_construction_header_location' );
    $architecture_construction_phone        = get_theme_mod( 'architecture_construction_header_phone' );
    $architecture_construction_email        = get_theme_mod( 'architecture_construction_header_email' );
    ?>
        <div class="header_info">
            <div class="row">
                <div class="col-lg-4 col-md-4 align-self-center">
                    <?php if ( $architecture_construction_email ){?>
                        <div class="row">
                            <div class="col-xl-2 col-lg-3 col-md-2 align-self-center">
                                <i class="<?php echo esc_attr(get_theme_mod('architecture_construction_email_icon','fas fa-envelope')); ?>"></i>

                            </div>
                            <div class="col-xl-9 col-lg-9 col-md-10 align-self-center">
                                <h6 class="mb-0"> <?php echo esc_html( 'Email','architecture-construction' );?></h6>
                                <a href="mailto:<?php echo esc_attr($architecture_construction_email);?>"> <?php echo esc_html($architecture_construction_email);?></a>
                            </div>
                        </div>
                    <?php } ?>
                </div>
                <div class="col-lg-4 col-md-4 align-self-center">
                    <?php if ( $architecture_construction_phone ){?>
                        <div class="row">
                            <div class="col-xl-2 col-lg-3 col-md-3 align-self-center">
                               <i class="<?php echo esc_attr(get_theme_mod('architecture_construction_phone_icon','fas fa-phone-alt')); ?>"></i>
                            </div>
                            <div class="col-xl-10 col-lg-9 col-md-9 align-self-center">
                                <h6 class="mb-0"> <?php echo esc_html( 'Call Us','architecture-construction' );?></h6>
                                <a href="tel:<?php echo esc_attr($architecture_construction_phone);?>"> <?php echo esc_html( $architecture_construction_phone);?></a>
                            </div>
                        </div>
                    <?php } ?>
                </div>
                <div class="col-lg-4 col-md-4 align-self-center">
                    <?php if ( $architecture_construction_location ){?>
                        <div class="row">
                            <div class="col-xl-2 col-lg-3 col-md-2 align-self-center">
                                <i class="<?php echo esc_attr(get_theme_mod('architecture_construction_Location_icon','fas fa-map-marker-alt')); ?>"></i>
                            </div>
                            <div class="col-xl-10 col-lg-9 col-md-10 align-self-center">
                                <h6 class="mb-0"> <?php echo esc_html( 'Location','architecture-construction' );?></h6>
                                <p class="mb-0"> <?php echo esc_html( $architecture_construction_location );?></p>
                            </div>
                        </div>
                    <?php } ?>
                </div>
            </div>
        </div>
    <?php
}
endif;

if( ! function_exists( 'architecture_construction_header' ) ) :
/**
 * Header Start
*/
function architecture_construction_header(){
    $architecture_construction_header_image = get_header_image();
    $architecture_construction_sticky_header = get_theme_mod('architecture_construction_sticky_header');
    ?>
    <div id="page-site-header" style="background-image: url('<?php echo esc_url( $architecture_construction_header_image ); ?>');">
        <header id="masthead" class="site-header header-inner" role="banner">
            <div class="container">
                <div class="row">
                    <div class="col-lg-3 col-md-12 align-self-center">
                        <?php architecture_construction_site_branding(); ?>
                    </div>
                    <div class="col-lg-9 col-md-12 align-self-center">
                        <?php architecture_construction_top_header(); ?>
                        <?php architecture_construction_header_info(); ?>                    
                    </div>                
                </div>
            </div>
            <div id="main-header" data-sticky="<?php echo $architecture_construction_sticky_header; ?>" class="header-menu">
                <div class="container">
                    <?php architecture_construction_navigation(); ?>
                </div>
            </div>        
        </header>
    </div>
    <?php
}
endif;
add_action( 'architecture_construction_header', 'architecture_construction_header', 20 );